--What to display when saving is in progress.
local love = assert( love )
local modal = require( "ui.modal" )
local button = require( "ui.button" )
local map = require( "map.map" )
local timer = love.timer
local time = 0

local t = { w = 400, h = 200 }
local progressMessage = ""

function t.start()
  time = timer.getTime()
  progressMessage = ""
  return modal.start( t )
end

function t.update( dt )
  local msg = map.save()
  if not msg then return t:stop() end
  progressMessage = msg
end

function t.draw()
  love.graphics.push( "all" )
  love.graphics.setCanvas()
  love.graphics.setShader()
  love.graphics.setScissor( 0, 0, t.w, t.h )
  love.graphics.clear()
  love.graphics.setColor( 1, 1, 1, 1 )
  love.graphics.print( timer.getTime() - time  )
  love.graphics.printf( progressMessage, 0, love.graphics.getFont():getHeight(), t.w, "left")
  love.graphics.pop( "all" )
end

return modal.new( t )